#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>
#include <X11/cursorfont.h>
#include <Xm/Xm.h>
#include <Xm/MessageB.h>
#include <Xm/TextF.h>
#include <stdio.h>
#include <stdlib.h>
#include "SciPlot.h"
#include "global.h"

void p_cb(Widget widget, XtPointer client_data, XtPointer call_data) {
  static Widget mbox, tfield;
  int           i;
  Arg           args[5];
  char          text[256];

  void print_cb(Widget, XtPointer, XtPointer);
  void printhelp_cb(Widget, XtPointer, XtPointer);
  extern void cancel_cb(Widget, XtPointer, XtPointer);

  if (!mbox) {
    i=0;
    XtSetArg(args[i], XmNmessageString, XmStringCreateLtoR("Enter Print Command:",XmFONTLIST_DEFAULT_TAG)); i++;
    XtSetArg(args[i], XmNtitle, "Printing"); i++;
    XtSetArg(args[i], XmNautoUnmanage, False); i++;
    mbox=XmCreateMessageDialog(drawing_a, "print", args, i);
    tfield=XtVaCreateWidget("tfield", xmTextFieldWidgetClass, mbox,
			    NULL);
    sprintf(text, PRINTCMD);
    XtVaSetValues(tfield,
		  XmNvalue, text,
		  XmNuserData, widget,
		  NULL);
    XtAddCallback(mbox, XmNokCallback, print_cb, tfield);
    XtAddCallback(mbox, XmNcancelCallback, cancel_cb, NULL);
    XtAddCallback(mbox, XmNhelpCallback, printhelp_cb, NULL);
  }
  XtManageChild(tfield);
  XtManageChild(mbox);
}


void print_cb(Widget widget, XtPointer client_data, XtPointer call_data) {
  Widget        plotw;
  Cursor        uhr, pfeil;
  float         *xval, *yval;
  float         ymin, ymax;
  int           i, j, list, npos, step, maxpix=1000, last;
  short         need_x_label, former_xtype;
  unsigned long n, na, ne, ni, nn;
  char          *fname, *filelist, *syscom, *printcom;

  xval    =new float[2];
  yval    =new float[2];
  fname   =new char[256];
  syscom  =new char[256];
  filelist=new char[256];
  uhr     =XCreateFontCursor(XtDisplay(widget),XC_watch);
  pfeil   =XCreateFontCursor(XtDisplay(widget), XC_arrow);


  XDefineCursor(XtDisplay(widget),XtWindow(widget),uhr);
  XFlush(XtDisplay(widget));
  XtVaGetValues((Widget)client_data, XmNvalue, &printcom, NULL);
  strcpy(filelist, " ");
  npos=0;
  for (i=0; i<r.n; i++) {
    if (r.view[i].is_visible) {
      na=(unsigned long)(r.t_1*r.ch[i].sr);
      if (na>=r.ch[i].n) na=r.ch[i].n-1;
      ne=(unsigned long)(r.t_2*r.ch[i].sr);
      if (ne>=r.ch[i].n) ne=r.ch[i].n-1;
      if (ne>na) {
	step=((ne-na+1)/maxpix)+1;
	if (step>1) {
	  xval=(float *)realloc(xval, 2*(sizeof(float)*(ne-na+1)/step+1));
	  yval=(float *)realloc(yval, 2*(sizeof(float)*(ne-na+1)/step+1));
	}
	else {
	  xval=(float *)realloc(xval, sizeof(float)*(ne-na+1));
	  yval=(float *)realloc(yval, sizeof(float)*(ne-na+1));
	}
	ni=0;
	for (n=na; n<=ne; n+=step) {
	  if (step>1) {
	    if (r.view[i].is_frequency) {
	      xval[2*ni]=(float)n*0.5*r.ch[i].sr/((float)(r.ch[i].n-1));
	      xval[2*ni+1]=(float)n*0.5*r.ch[i].sr/((float)(r.ch[i].n-1));
	    }
	    else {
	      xval[2*ni]=(float)n/r.ch[i].sr;
	      xval[2*ni+1]=(float)n/r.ch[i].sr;
	    }
	    ymin=r.ch[i].data[n];
	    ymax=r.ch[i].data[n];
	    for (nn=n+1; nn<n+step; nn++) {
	      if (nn<r.ch[i].n) {
		if (ymin>r.ch[i].data[nn]) ymin=r.ch[i].data[nn];
		if (ymax<r.ch[i].data[nn]) ymax=r.ch[i].data[nn];
	      }
	    }
	    yval[2*ni]=ymin;
	    yval[2*ni+1]=ymax;
	  }
	  else {
	    if (r.view[i].is_frequency) 
	      xval[n-na]=(float)n*0.5*r.ch[i].sr/((float)(r.ch[i].n-1));
	    else 
	      xval[n-na]=(float)n/r.ch[i].sr;
	    yval[n-na]=r.ch[i].data[n];
	  }
	  ni++;
	}
	plotw=XtVaCreateManagedWidget("plot", sciplotWidgetClass, drawing_a,
				      XtNheight, 360/r.nvis,
				      XtNwidth, 252,
				      XtNshowLegend, False,
				      XtNshowTitle, False,
				      XtNshowXLabel, False,
				      XtNshowYLabel, False,
				      XtNdrawMinor, False,
				      XtNyNumbersHorizontal, True,
				      XtNaxisFont, XtFONT_HELVETICA|5,
				      XtNlabelFont, XtFONT_HELVETICA|5,
				      XtNtitleFont, XtFONT_HELVETICA|5,
				      XtNmonochrome, True,
				      XtNchartType, XtCARTESIAN,
				      NULL);
	/* find out whether x-axis label is needed */
	last=r.n-1;
	while (!r.view[last].is_visible && last>=0) last--;
	former_xtype=r.view[last].is_frequency;
	need_x_label=1;
	for (j=last-1; j>=i; j--) {
	  if (r.view[j].is_visible) {
	    if (former_xtype==r.view[j].is_frequency) {
	      need_x_label=0;
	    }
	    else {
	      need_x_label=1;
	      former_xtype=r.view[j].is_frequency;
	    }
	  }
	}

	if (need_x_label) {
	  if (r.view[i].is_frequency)
	    XtVaSetValues(plotw,
			  XtNshowXLabel, True,
			  XtNxLabel, "frequency (Hz)",
			  NULL);
	  else 
	    XtVaSetValues(plotw,
			  XtNshowXLabel, True,
			  XtNxLabel, "time (sec)",
			  NULL);
	}
	if (step>1)
	  list=SciPlotListCreateFromFloat(plotw, 2*ni, xval, yval, " ");
	else
	  list=SciPlotListCreateFromFloat(plotw, (ne-na+1), xval, yval, " ");
	SciPlotListSetStyle(plotw, list, 1, XtMARKER_NONE, 1, XtLINE_SOLID);
	SciPlotUpdate(plotw);
	sprintf(fname, "/tmp/xmana%d.ps", i);
	SciPlotPSCreate(plotw, fname, r.nvis, npos);
	XtDestroyWidget(plotw);
	npos++;
	strcat(filelist, fname); strcat(filelist, " ");
      }
    }
  }

  strcpy(syscom, "cat");
  strcat(syscom, filelist); strcat(syscom, "> "); strcat(syscom, "/tmp/xmana.ps");
  system(syscom);
  strcpy(syscom, "rm"); strcat(syscom, filelist);
  system(syscom);
  strcpy(syscom, printcom); strcat(syscom, " /tmp/xmana.ps");
  system(syscom);

  XtUnmanageChild(widget);
  XDefineCursor(XtDisplay(widget),XtWindow(widget),pfeil);
  XFlush(XtDisplay(widget));

  XFreeCursor(XtDisplay(widget), pfeil);
  XFreeCursor(XtDisplay(widget), uhr);
  XtFree(printcom);
  delete[]xval; delete[]yval;
  delete[]fname; delete[]filelist;
  delete[]syscom;
}

void printhelp_cb(Widget widget, XtPointer client_data, XtPointer call_data) {
  extern void showmess(Widget widget, char *title, char *text);

  showmess(widget, "Help for Print", "Enter a command that can print a postscript file.\nTo redirect the ouput on a postscript file enter:\n               cat > filename.ps <");

}
